/*
 *  TOPPERS/ASP Kernel
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      Advanced Standard Profile Kernel
 * 
 *  Copyright (C) 2008-2010 by Witz Corporation, JAPAN
 *  Copyright (C) 2013      by Mitsuhiro Matsuura
 * 
 *  L쌠҂́Cȉ(1)`(4)̏𖞂ꍇɌC{\tgEF
 *  Ai{\tgEFAς̂܂ށDȉjgpEE
 *  ρEĔzziȉCpƌĂԁj邱Ƃ𖳏ŋD
 *  (1) {\tgEFA\[XR[ȟ`ŗpꍇɂ́CL̒
 *      \C̗pщL̖ۏ؋K肪Ĉ܂܂̌`Ń\[
 *      XR[hɊ܂܂Ă邱ƁD
 *  (2) {\tgEFACCu`ȂǁC̃\tgEFAJɎg
 *      pł`ōĔzzꍇɂ́CĔzzɔhLgip
 *      ҃}jAȂǁjɁCL̒쌠\C̗pщL
 *      ̖ۏ؋Kfڂ邱ƁD
 *  (3) {\tgEFAC@ɑgݍނȂǁC̃\tgEFAJɎg
 *      płȂ`ōĔzzꍇɂ́Ĉꂩ̏𖞂
 *      ƁD
 *    (a) ĔzzɔhLgip҃}jAȂǁjɁCL̒
 *        쌠\C̗pщL̖ۏ؋Kfڂ邱ƁD
 *    (b) Ĕzž`ԂCʂɒ߂@ɂāCTOPPERSvWFNg
 *        񍐂邱ƁD
 *  (4) {\tgEFA̗pɂ蒼ړI܂͊ԐړIɐ邢Ȃ鑹
 *      QCL쌠҂TOPPERSvWFNgƐӂ邱ƁD
 *      ܂C{\tgEFÃ[U܂̓Gh[ÛȂ闝
 *      RɊÂCL쌠҂TOPPERSvWFNg
 *      Ɛӂ邱ƁD
 * 
 *  {\tgEFÁCۏ؂Œ񋟂Ă̂łDL쌠҂
 *  TOPPERSvWFNǵC{\tgEFAɊւāC̎gpړI
 *  ɑ΂K܂߂āCȂۏ؂sȂD܂C{\tgEF
 *  A̗pɂ蒼ړI܂͊ԐړIɐȂ鑹QɊւĂC
 *  ̐ӔC𕉂ȂD
 * 
 *  @(#) $Id: rx630_config.h 167 2016-03-08 11:37:45Z coas-nagasima $
 */

/*
 *		vZbTˑW[iRX630pj
 *
 *  ̃CN[ht@ĆCtarget_config.hi܂́CCN
 *  [ht@Cĵ݂CN[hD̃t@C
 *  ڃCN[hĂ͂ȂȂD
 */


#ifndef TOPPERS_RX630_CONFIG_H
#define TOPPERS_RX630_CONFIG_H


/*
 *  ݗv
 */
#define	INHNO_MAX	UINT_C( 256 )


/*
 *  ݐp^`
 */
typedef struct ier_info {
	volatile uint8_t __evenaccess	*addr;
			 uint8_t				offset;
} IER_INFO;


/*
 *  ݐp`
 */
#define	INVALID_OFFSET				( 0xFFU )
#define	INTNO_IRQ( intno )			( ( 64U <= ( intno ) ) && ( ( intno ) <= 79U ) )
#define	INTNO_IRQ_OFFSET( intno )	( ( intno ) - 64U )
#define	IRQ_MAX						UINT_C( 16 )

#define IR_TOP						(0x00087010)
#define IR_REG( intno )				((volatile uint8_t __evenaccess * )(IR_TOP + (intno)))

/*
 *  ݐpe[u
 */

/* ݗvvCIeBWX^AhX */
extern volatile uint8_t __evenaccess * const ipr_reg_addr[];
/* ݗvWX^AhX */
extern const IER_INFO ier_reg_addr[];
/* ݗvWX^AhX */
extern volatile uint8_t __evenaccess * const ir_reg_addr[];
/* IRQRg[WX^AhX */
extern volatile uint8_t __evenaccess * const irqcr_reg_addr[];


/*
 *  vZbTˑW[iRX630pj
 */
#include "rx630_ccrx/prc_config.h"

#endif	/* TOPPERS_RX630_CONFIG_H */

